#!/usr/bin/wish

# NUON flash update program

# $Id: nuon-flash.tcl,v 1.12 2001/06/07 23:15:59 lreeber Exp $

global boldfont normalfont
set boldfont "Helvetica 10 bold"
set normalfont "Helvetica 10"

global developer systype video uiChoice flashPause confirmSettings
global doHAL doBIOS doPE doUI
global useVmlabsLocal
global vmlabsDir vmlabsLoadDir env
global confirmResult

set version "NUON flash update program 0.06"

set doHAL 1
set doBIOS 1
set doPE 1
set doUI 1
set useVmlabsLocal no
set confirmSettings yes
set rowNum 0
set confirmResult yes

	# we need to do it this way, because tcl barfs if you access an environment
	# variable that isn't there.

    set vmlabsDir ""
    set vmlabsLocalDir ""
    set mdPort ""

    set foo [array names env VMLABS]
    if {$foo != ""} {
	set vmlabsDir $env(VMLABS)
    } else {
	tk_messageBox -icon error -message "VMLABS environment variable is not defined!" -type ok -title "Missing environment variable"
	exit -1
    }

    set foo [array names env VMLABS_LOCAL]
    if {$foo != ""} {
	set vmlabsLocalDir $env(VMLABS_LOCAL)
	set vmlabsLocalActive "normal"
    } else {
	set vmlabsLocalDir ""
	set vmlabsLocalActive "disabled"
    }

    set foo [array names env MD_PORT]
    if {$foo != ""} {
	set mdPort $env(MD_PORT)
    } else {
#	tk_messageBox -icon error -message "MD_PORT environment variable is not defined!" -type ok -title "Missing environment variable"
#	exit -1
    }

frame .rc -borderwidth 2
wm title . $version
pack .rc
frame .rc.choices -relief sunken -bd 3
frame .rc.buttons -borderwidth 2 -relief raised -bd 3

set rowNum 0
label .rc.choices.devlabel -text Developer: -font $boldfont
set developer developer
radiobutton .rc.choices.devyes -text Yes -font $normalfont -variable developer -value developer
radiobutton .rc.choices.devno -text No -font $normalfont -variable developer -value player
grid .rc.choices.devlabel -row $rowNum -column 0 -sticky e
grid .rc.choices.devyes -row $rowNum -column 1 -sticky w
grid .rc.choices.devno -row $rowNum -column 2 -sticky w
incr rowNum

# Currently don't need a different version of the boot images for different
# systems... not sure when this will change again so I'll just comment out. 
# label .rc.choices.syslabel -text System: -font $boldfont
set systype whitebox
# radiobutton .rc.choices.sysclearcase -text {Clear case} -font $normalfont -variable systype -value clearcase
# radiobutton .rc.choices.syswhitebox -text {White box} -font $normalfont -variable systype -value whitebox
# radiobutton .rc.choices.sysrev6 -text {Rev 6} -font $normalfont -variable systype -value rev6 -disabledforeground darkgray -state disabled
# grid .rc.choices.syslabel -row $rowNum -column 0 -sticky e
# grid .rc.choices.sysclearcase -row $rowNum -column 1 -sticky w
# grid .rc.choices.syswhitebox -row $rowNum -column 2 -sticky w
# grid .rc.choices.sysrev6 -row $rowNum -column 3 -sticky w
# incr rowNum

label .rc.choices.videoLabel -text Video: -font $boldfont
set video NTSC
radiobutton .rc.choices.videoNTSC -text "NTSC" -font $normalfont -variable video -value NTSC
radiobutton .rc.choices.videoPAL -text "PAL" -font $normalfont -variable video -value PAL
grid .rc.choices.videoLabel -row $rowNum -column 0 -sticky e
grid .rc.choices.videoNTSC -row $rowNum -column 1 -sticky w
grid .rc.choices.videoPAL -row $rowNum -column 2 -sticky w
incr rowNum

set uiChoice Euro
label .rc.choices.uiLabel -text "UI:" -foreground darkgray -font $boldfont
radiobutton .rc.choices.uiEuro -text "Euro" -font $normalfont -variable uiChoice -value Euro -state disabled -disabledforeground darkgray -selectcolor pink
grid .rc.choices.uiLabel -row $rowNum -column 0 -sticky e
grid .rc.choices.uiEuro -row $rowNum -column 1 -sticky w
incr rowNum

label .rc.choices.compLabel -text Components: -font $boldfont
set doHAL 1
set doBIOS 1
set doPE 1
set doUI 1
checkbutton .rc.choices.doHAL -text HAL -font $normalfont -variable doHAL
checkbutton .rc.choices.doBIOS -text BIOS -font $normalfont -variable doBIOS
checkbutton .rc.choices.doPE -text PE -font $normalfont -variable doPE
checkbutton .rc.choices.doUI -text GUI -font $normalfont -variable doUI
grid .rc.choices.compLabel -row $rowNum -column 0 -sticky e
grid .rc.choices.doHAL -row $rowNum -column 1 -sticky w
grid .rc.choices.doBIOS -row $rowNum -column 2 -sticky w
grid .rc.choices.doPE -row $rowNum -column 3 -sticky w
grid .rc.choices.doUI -row $rowNum -column 4 -sticky w
incr rowNum

set flashPause no
checkbutton .rc.choices.flashPause -text "Pause to let me switch the ROM/Flash jumper" -font $normalfont -variable flashPause -onvalue yes -offvalue no 
grid .rc.choices.flashPause -row $rowNum -column 0 -columnspan 4 -sticky w
incr rowNum

set useVmlabsLocal no
checkbutton .rc.choices.useLocal -text "Search VMLABS_LOCAL for files" -font $normalfont -variable useVmlabsLocal -onvalue yes -offvalue no -disabledforeground darkgray -state $vmlabsLocalActive
grid .rc.choices.useLocal -row $rowNum -column 0 -columnspan 4 -sticky w
incr rowNum

button .rc.buttons.reset -text "Reset" -font $boldfont -command { doReset } -default normal
button .rc.buttons.flash -text "Flash" -font $boldfont -command {
	disableButtons
	doFlash
	enableButtons } -default active
button .rc.buttons.defaults -text "Defaults" -font $boldfont -command { resetValues } -default normal
button .rc.buttons.quit -text "Quit" -font $boldfont -command {exit} -default normal
set rowNum 0
grid .rc.buttons.reset -row $rowNum -column 0 -padx 10
grid .rc.buttons.flash -row $rowNum -column 1 -padx 10
grid .rc.buttons.defaults -row $rowNum -column 2 -padx 10
grid .rc.buttons.quit -row $rowNum -column 3 -padx 10
proc disableButtons {} {
    .rc.buttons.reset configure -state disabled
    .rc.buttons.flash configure -state disabled
    .rc.buttons.defaults configure -state disabled
    .rc.buttons.quit configure -state disabled
    update
}
proc enableButtons {} {
    .rc.buttons.reset configure -state normal
    .rc.buttons.flash configure -state normal
    .rc.buttons.defaults configure -state normal
    .rc.buttons.quit configure -state normal
    update
}
frame .rc.msg
message .rc.msg.msg -text "" -font $normalfont -width 200 -anchor nw -justify left
global messagebg
set messagebg [ .rc.msg.msg cget -background ]
pack .rc.msg.msg -expand 1 -fill x

pack .rc.choices -fill both -expand true
pack .rc.buttons -fill x -expand true
pack .rc.msg -fill x -expand true

proc doReset {} {
    newMsg "Resetting... " 0
    exec mload "-!"
    newMsg "Resetting... done." 0
}

proc resetValues {} {
    global developer systype video flashPause uiChoice confirmSettings doHAL doBIOS doPE doUI useVmlabsLocal

    set developer developer
    set systype whitebox
    set video NTSC
    set uiChoice Euro
    set flashPause no
    set confirmSettings no
    set doHAL 1
    set doBIOS 1
    set doPE 1
    set doUI 1
    set useVmlabsLocal no
    newMsg "Configuration reset" 0
}

proc doFlash {} {
    global developer systype video flashPause confirmSettings doHAL doBIOS doPE doUI
    global vmlabsDir vmlabsLocalDir

    if { $doHAL || $doBIOS || $doPE || $doUI } {
    } else {
	newMsg "There are no components selected." 1
	return
    }

    if { $video == "PAL" } {
    	set vidtype "-pal"
    } else {
    	set vidtype {}
    }

    if { $doHAL == 1 } {
	if { $systype == "clearcase"} {
	    set halName "refHAL-cc.zcof"
	} else {
	    set halName "refHAL.zcof"
	}
	set halName [findpath $halName]
    } else {
	set halName ""
    }

    if { $doBIOS == 1 } {
	if { $developer == "developer" } {
		append biosName "aries-dvd-dev" $vidtype ".bin"
	} else {
	    append biosName "ref-system" $vidtype ".bin"
	}
	set biosName [findpath $biosName]
    } else {
	set biosName ""
    }

    if { $doPE == 1 } {
	set peName "RefPE.zcof"
	set peName [findpath $peName]
    } else {
	set peName ""
    }

    if { $doUI == 1 } {
	append guiName [findpath "player.zcof"]
	append guiDataName [findpath "refUIeuro.dat"]
    } else {
	set guiName ""
	set guiDataName ""
    }

    set reallyDoIt [doConfirm $halName $biosName $peName $guiName $guiDataName]

    if { $reallyDoIt != "yes" } {
	newMsg "Cancelled." 0
	return
    }

    newMsg "Resetting..." 0
    if { $flashPause == "yes" } {
	exec mload "-!"
        newMsg "Pausing to switch jumper..." 2
	tk_messageBox -type ok -default ok -icon info -title "" -message "Switch the ROM/Flash jumper to Flash, then click OK."
	newMsg "OK" 0
    } else {
	exec mload "-!" "-w" "-w" "-w" "-w"
    }

    newMsg "Loading flash receive app..." 0
    append fname $vmlabsDir "/bin/NUON/flashRcv" $vidtype ".cof"
    exec mload "-p3" "-h" "-w" "-p0" [file nativename $fname ] "-r"
    newMsg "Loading flash receive app... done." 0

    if { $doHAL == 1 } then {
        newMsg "HAL... " 0
	append halName ":f01e0000"
	exec mload "-fl" $halName "-w"
	newMsg "HAL... done." 0
    }

    if { $doBIOS == 1 } then {
        newMsg "BIOS... " 0
	append biosName ":f0000000"
	exec mload "-fl" $biosName "-w"
	newMsg "BIOS... done." 0
    }

    if { $doPE == 1 } then {
    	newMsg "PE... " 0
	append peName ":f0130000"
	exec mload "-fl" $peName "-w"
	newMsg "PE... done." 0
    }

    if { $doUI == 1 } then {
        newMsg "GUI... " 0
	append guiName ":f0200000"
	exec mload "-fl" $guiName "-w"
	newMsg "GUI... GUI data... " 0
	append guiDataName ":f0280000"
	exec mload "-fl" $guiDataName "-w"
	newMsg "GUI... GUI data... done." 0
    }

    newMsg "Done." 0
}


proc newMsg { val iserror} {
    global boldfont normalfont messagebg
    .rc.msg.msg configure -text $val
    if { $iserror == 1 } then {
    	.rc.msg.msg configure -background yellow -font $boldfont
    } elseif { $iserror == 2 } then {
    	.rc.msg.msg configure -background lightyellow -font $normalfont
    } else {
    	.rc.msg.msg configure -background $messagebg -font $normalfont
    }
    update
}


proc findpath { fname } {
    global useVmlabsLocal vmlabsDir vmlabsLocalDir

    set fullname ""
    if { $useVmlabsLocal == "yes" } {
		# check VMLABS_LOCAL first
	append fullname $vmlabsLocalDir "/bin/NUON/" $fname
	if { [file exists [file nativename $fullname]] == 1 } {
		# this is the one we want
	    return [file nativename $fullname]
	}
    }
	# always check VMLABS
    set fullname ""
    append fullname $vmlabsDir "/bin/NUON/" $fname
    return [file nativename $fullname]
}

proc doConfirm { halName biosName peName guiName guiDataName } {
    global confirmResult normalfont boldfont

    toplevel .confirm
    frame .confirm.files -relief sunken -bd 2
    frame .confirm.buttons -relief raised -bd 2
    set rowNum 0
    set confirmResult yes

    if { $halName != "" } {
	label .confirm.files.hal -text HAL: -font $normalfont
	label .confirm.files.halName -text $halName -font $normalfont
	grid .confirm.files.hal -row $rowNum -column 0 -sticky e
	grid .confirm.files.halName -row $rowNum -column 1 -sticky w
	incr rowNum
    }

    if { $biosName != "" } {
	label .confirm.files.bios -text BIOS: -font $normalfont
	label .confirm.files.biosName -text $biosName -font $normalfont
	grid .confirm.files.bios -row $rowNum -column 0 -sticky e
	grid .confirm.files.biosName -row $rowNum -column 1 -sticky w
	incr rowNum
    }

    if { $peName != "" } {
	label .confirm.files.pe -text PE: -font $normalfont
	label .confirm.files.peName -text $peName -font $normalfont
	grid .confirm.files.pe -row $rowNum -column 0 -sticky e
	grid .confirm.files.peName -row $rowNum -column 1 -sticky w
	incr rowNum
    }

    if { $guiName != "" } {
	label .confirm.files.gui -text GUI: -font $normalfont
	label .confirm.files.guiName -text $guiName -font $normalfont
	grid .confirm.files.gui -row $rowNum -column 0 -sticky e
	grid .confirm.files.guiName -row $rowNum -column 1 -sticky w
	incr rowNum
    }

    if { $guiDataName != "" } {
	label .confirm.files.guiData -text "GUI data:" -font $normalfont
	label .confirm.files.guiDataName -text $guiDataName -font $normalfont
	grid .confirm.files.guiData -row $rowNum -column 0 -sticky e
	grid .confirm.files.guiDataName -row $rowNum -column 1 -sticky w
	incr rowNum
    }

    if { $rowNum == 0 } {
	tk_messageBox -title "No files selected" -message "You have not specified any files to load!" -icon error -type ok
	set result no
    } else {
	button .confirm.buttons.ok -text OK -font $boldfont -default active -command {set confirmResult yes}
	button .confirm.buttons.cancel -text Cancel -font $boldfont -command {set confirmResult no}
	grid .confirm.buttons.ok -row 0 -column 0
	grid .confirm.buttons.cancel -row 0 -column 1

	pack .confirm.files -fill x -expand yes -padx 4
	pack .confirm.buttons -fill x -expand yes -padx 4

	vwait confirmResult
    }

    destroy .confirm
    return $confirmResult
}

newMsg "Ready." 0
