/*
 * BIOS time-releated functions
 *
 * Copyright (c) 1998 VM Labs, Inc.
 * All rights reserved.
 * Confidential and Proprietary Information
 * of VM Labs, Inc.
 */

#ifndef _BIOS_TIME_H
#define _BIOS_TIME_H

#ifdef __cplusplus
extern "C" {
#endif

/* structure for time of day */
struct _currenttime {
    int sec;
    int min;
    int hour;
    int wday;
    int mday;
    int month;
    int year;
    int isdst;     /* flag: for definitions, see below */
    int timezone;  /* minutes west of Greenwich */
    int reserved[3]; /* reserved for future expansion */
};

/* values for isdst */
#define _DST_UNKNOWN -1  /* whether DST is in effect is unknown */
#define _DST_NO      0   /* DST is not in effect */
#define _DST_YES     1   /* DST is in effect */

int _TimeOfDay(struct _currenttime *tm, int getset);
unsigned long _TimeElapsed(long *secs, long *usecs);

void _TimeToSleep(unsigned long msecs);
int _TimerInit(int which, int rate);


#ifdef __cplusplus
}
#endif

#endif
