/*
 * MML 3D camera functions
 *
 * Copyright (c) 1997-1998 VM Labs, Inc.
 * All rights reserved.
 * Confidential and Proprietary Information
 * of VM Labs, Inc.
 */

#include <stdlib.h>
#include "m3d.h"

/*
 * initialize a camera structure
 */

void
m3dInitCamera(m3dCamera *cam, m3dreal focalLength, m3dreal maxZ)
{
    m3dIdentityMatrix(&cam->matrix);
    cam->focalLength = focalLength;
    cam->backClip = maxZ;
}

/*
 * set the viewing matrix for a camera
 * we will actually want to use the
 * inverse of the matrix for most purposes
 * so that's what we keep
 */

void
m3dSetCameraMatrix(m3dCamera *cam, m3dMatrix *mat)
{
    m3dInvertTransformMatrix(&cam->matrix, mat);
}
