/*
 * functions for manipulating materials
 *
 * Copyright (c) 1997-1998 VM Labs, Inc.
 * All rights reserved.
 * Confidential and Proprietary Information
 * of VM Labs, Inc.
 */
/* $Id: m3dmat.c,v 1.11 2000/10/31 23:57:11 lreeber Exp $ */

#include <stdlib.h>
#include <nuon/dma.h>
#include <nuon/mml2d.h>
#include <assert.h>
#include "m3d.h"

/*
 * create a texture from a pixmap
 * CAVEAT: can't do CLUT materials (yet)
 */
void
m3dInitMaterialFromPixmap(m3dMaterial *mat, mmlDisplayPixmap *pmap)
{
    mat->dmaflags = pmap->dmaFlags | DMA_READ_BIT;
    mat->dataptr = pmap->memP;
    mat->width = pmap->wide;
    mat->height = pmap->high;
    mat->matflags = 0;
}

/*
 * create a texture from a color
 */
void
m3dInitMaterialFromColor(m3dMaterial *mat, mmlColor color)
{
    mat->dmaflags = (1<<16)|(2<<4) | DMA_PIXEL_READ;
    mat->dataptr = (void *)color;
    mat->width = 1;
    mat->height = 1;
    mat->matflags = M3D_MATERIAL_SOLID;
}

#if 0
/*
 * create a mip-map from an array of textures
 * the textures should be laid out with
 * the smallest texture first
 */

m3dMaterial *
m3dMakeMipMap(int numtexs, m3dMaterial **texs)
{
    int level;

    m3dMaterial *mipmap, *ptr;

    ptr = mipmap = malloc(numtexs*sizeof(*mipmap));
    if (!mipmap) return mipmap;

    for (level = numtexs-1; level >= 0; --level) {
	*ptr = *texs[0]; texs++;
	ptr->matflags &= ~M3D_MIPMAPLEVEL;
	ptr->matflags |= (level << M3D_MIPMAPLEVEL_BITS);
	ptr++;
    }
    return mipmap;
}
#endif
