/*
 * video setup code
 *
 * Copyright (c) 1997-2000 VM Labs, Inc. All rights reserved.
 * Confidential and Proprietary Information of VM Labs, Inc.
 * These materials may be used or reproduced solely under
 * an express written license from VM Labs, Inc.
 */

#include <nuon/video.h>

/* default border color is black */
#define DEFAULT_BORDER_COLOR 0x10808000

/*
 * create a full screen (720x480) image of the supplied frame buffer
 */

void
VidSetup(void *baseaddr, long dmaflags, int dmawidth, int dmaheight, int filtertype)
{
    VidDisplay display;
    VidChannel mainch;

    memset(&display, 0, sizeof(display));
    memset(&mainch, 0, sizeof(mainch));

    display.dispwidth = -1;
    display.dispheight = -1;
    display.bordcolor = DEFAULT_BORDER_COLOR;
    display.progressive = 0;

    mainch.dmaflags = dmaflags;
    mainch.base = baseaddr;
    mainch.dest_xoff = -1;
    mainch.dest_yoff = -1;
    mainch.dest_width = 720;
    mainch.dest_height = 479; // WAS 480; 479 works around a bug in early
                              // BIOSes

    mainch.src_xoff = 0;
    mainch.src_yoff = 0;
    mainch.src_width = dmawidth;
    mainch.src_height = dmaheight;
    mainch.vfilter = filtertype;
    mainch.hfilter = VID_HFILTER_4TAP;

    _VidConfig(&display, &mainch, (VidChannel *)0, (void *)0);
}

