/*
 * hello, world -- test of some nuon library functions
 *
 * Copyright (c) 1997-1999 VM Labs, Inc.
 * All rights reserved.
 *
 * Confidential and Proprietary Information of VM Labs, Inc.
 */

#include <nuon/dma.h>
#include <nuon/mutil.h>

/*
 * defaults for things
 */

#define SCRNWIDTH 360
#define SCRNHEIGHT 240
#define DMA_XFER_TYPE 4
#define SCREEN ((void *)0x40000000)
#define FGCOLOR 0xc0808000  /* white */
#define BGCOLOR 0x60808000  /* grey */
#define XSIZE ((SCRNWIDTH/8)<<16)
#define DMAFLAGS (DMA_PIXEL_WRITE | XSIZE | (DMA_XFER_TYPE<<4))


void ClearScreen()
{
long x, y;

    for (x = 0; x < SCRNWIDTH; x += 8)
	{
		for (y = 0; y < SCRNHEIGHT; y += 8)
		{
			_raw_plotpixel(DMAFLAGS, SCREEN, (8<<16)|x, (8<<16)|y, BGCOLOR);
		}
    }
}

int main()
{
    /* clear the screen */
    ClearScreen();

    /* turn on video */
    VidSetup(SCREEN, DMAFLAGS, SCRNWIDTH, SCRNHEIGHT, 0);

    /* write our messages */
    DebugWS(DMAFLAGS, SCREEN, 32, 40, FGCOLOR, "Hello World!");
    DebugWS(DMAFLAGS, SCREEN, 32, 100, FGCOLOR, "0123456789");
    DebugWS(DMAFLAGS, SCREEN, 32, 130, FGCOLOR, "ABCDEFGHIJKLMNOPQRSTUVWXYZ");
    DebugWS(DMAFLAGS, SCREEN, 32, 160, FGCOLOR, "abcdefghijklmnopqrstuvwxyz");

    /* sit in a loop */
    while(1);

	/* Never get here */
	return 0;
}
