#!/usr/bin/wish

#############################################################################

# Visual Tcl v1.11 Project

#



#################################

# GLOBAL VARIABLES

#

global synthVol

global pcmVol

global ExtendedInfo; 

global MaxVoices; 

global ParserState; 

global Voices; 

global chorusSwitch; 

global cpuUsage; 

global fast; 

global ffimage; 

global maxVoices; 

global playimage; 

global reverbSwitch; 

global stopimage; 

global voiceKilling; 

global widget; 

    set widget(INFO) {.top17.lab17}

    set widget(PROGRESS) {.top17.can17}

    set widget(rev,.top17.can17) {PROGRESS}

    set widget(rev,.top17.lab17) {INFO}



#################################

# USER DEFINED PROCEDURES

#

proc init {argc argv} {

global playimage;

global stopimage;

global ffimage;



set playdata {R0lGODlhGAAUALMAAP///+7u7t3d3czMzLu7u6qqqoiIiCIiIgAAAAAAAAAAAAAAAAAAAAAA

AAAAAAAAACwAAAAAGAAUAAAEbRCgSau9SILNu//CtAVkaZ6lQIiB4L5w/A5r1so4TLOykc81

wA2GOPhyO5sMYSgeY0nh0kB1QoPDF5NafQqiWdeWC7jyYuOyDDxV49gxNxL7+8HrazoeGv0O

/oCBgn8ENSqFiImKigUZGI8YABEAOw==}



set stopdata {R0lGODlhGAAUALMAAP///+7u7t3d3czMzLu7u6qqqoiIiHd3dwAAAAAAAAAAAAAAAAAAAAAA

AAAAAAAAACwAAAAAGAAUAAAEZxCgSau9SILNu//CtAVkaZ6lQIik4L5w7A5rFsh4TLN5L+w2

GUZXA9xiiINSaSDykEumMwiNNmFAozB6uL6yR1jSOtUiDeh0Oexbt3Hgtywu/2Z/g7x+z88T

aip/goOEhAUZGIkYABEAOw==}



set ffdata {R0lGODlhGAAUALMAAP///+7u7t3d3czMzLu7u6qqqoiIiCIiIgAAAAAAAAAAAAAAAAAAAAAA

AAAAAAAAACwAAAAAGAAUAAAEeBCgSau9SILNu//CtAVkaZ6lQIiB4L5w/A5r1so4TLOx8fq4

nS028SEOQF0NcHshDBQoUsmDPQ1QrBQoZBK1V7Cv23SFw1iAi/zFhtWzZTlkUD/h1CEMj4+x

c4B/gEFyg0FdAgOKi4yNiwQ1KpCTlJWVBRkYmhgAEQA7}



set playimage [image create photo -data $playdata]

set stopimage [image create photo -data $stopdata]

set ffimage [image create photo -data $ffdata]

}



set synthVol 0.5

set pcmVol 0.5



init $argc $argv





proc {main} {argc argv} {



}



proc {Window} {args} {

global vTcl

    set cmd [lindex $args 0]

    set name [lindex $args 1]

    set newname [lindex $args 2]

    set rest [lrange $args 3 end]

    if {$name == "" || $cmd == ""} {return}

    if {$newname == ""} {

        set newname $name

    }

    set exists [winfo exists $newname]

    switch $cmd {

        show {

            if {$exists == "1" && $name != "."} {wm deiconify $name; return}

            if {[info procs vTclWindow(pre)$name] != ""} {

                eval "vTclWindow(pre)$name $newname $rest"

            }

            if {[info procs vTclWindow$name] != ""} {

                eval "vTclWindow$name $newname $rest"

            }

            if {[info procs vTclWindow(post)$name] != ""} {

                eval "vTclWindow(post)$name $newname $rest"

            }

        }

        hide    { if $exists {wm withdraw $newname; return} }

        iconify { if $exists {wm iconify $newname; return} }

        destroy { if $exists {destroy $newname; return} }

    }

}



#################################

# VTCL GENERATED GUI PROCEDURES

#



proc vTclWindow. {base} {

    if {$base == ""} {

        set base .

    }

    ###################

    # CREATING WIDGETS

    ###################

    wm focusmodel $base passive

    wm geometry $base 200x200+0+0

    wm maxsize $base 1137 870

    wm minsize $base 96 1

    wm overrideredirect $base 0

    wm resizable $base 0 0

    wm withdraw $base

    wm title $base "vt.tcl"

    ###################

    # SETTING GEOMETRY

    ###################

}



proc vTclWindow.top17 {base} {

global playimage

global stopimage

global ffimage

global synthVol

global pcmVol

global chorusSwitch; 

global cpuUsage; 

global maxVoices; 

global reverbSwitch; 

global voiceKilling; 



    if {$base == ""} {

        set base .top17

    }

    if {[winfo exists $base]} {

        wm deiconify $base; return

    }

    ###################

    # CREATING WIDGETS

    ###################

    toplevel $base -class Toplevel \

        -menu .top17.m18 

    wm focusmodel $base passive

    wm geometry $base 366x288+200+555

    wm maxsize $base 1265 994

    wm minsize $base 1 1

    wm overrideredirect $base 0

    wm resizable $base 0 0

    wm deiconify $base

    wm title $base "Merlin Synth"

    bind $base <Destroy> {

        exit

    }

    menu $base.m18 \

        -cursor {} -tearoff 0 

    label $base.lab19 \

        -background #8678df -borderwidth 1 -font {Helvetica -18 bold italic} \

        -relief raised -text {MIDI Panel} 

    button $base.but22 \

        -command exit -foreground #000000 -padx 9 -pady 3 -text Exit 

    label $base.lab17 \

        -borderwidth 1 -font {Helvetica -12} -text {Synth Protocol V???} 

    frame $base.fra17 \

        -borderwidth 2 -height 75 -relief groove -width 125 

    button $base.fra17.but19 \

        \

        -command {set types {

          {{MIDI Files} {.mid} MIDI}

	  {{All files}   *         }

          }

set file [tk_getOpenFile -filetypes $types]

if {$file != ""} {

    DownloadMIDI $file

}} \

        -padx 9 -pady 3 -text {Open MIDI file} 

    button $base.fra17.but17 \

        -command {SendCommand 129} -image $playimage -padx 9 -pady 3 

    button $base.fra17.but18 \

        -command {SendCommand 130} -image $stopimage -padx 9 -pady 3 

    checkbutton $base.fra17.che21 \

        -command {FastForward $fast} -image $ffimage -indicatoron 0 \

        -variable fast 

    frame $base.fra20 \

        -borderwidth 2 -height 75 -relief groove -width 125 

    label $base.fra20.lab21 \

        -borderwidth 1 -font {Helvetica -12} -text {Parser State:} 

    label $base.fra20.lab22 \

        -borderwidth 1 -font {Helvetica -12} -text {Used voices:} 

    label $base.fra20.lab24 \

        -borderwidth 1 -font {Helvetica -12} -foreground blue -text 0 \

        -textvariable ParserState 

    label $base.fra20.lab25 \

        -borderwidth 1 -font {Helvetica -12} -foreground blue -text 0 \

        -textvariable Voices 

    label $base.fra20.lab18 \

        -borderwidth 1 -font {Helvetica -12} -foreground #f80000 -text 0 \

        -textvariable MaxVoices 

    checkbutton $base.che17 \

        -command {InfoSwitch $ExtendedInfo} -font {Helvetica -12} \

        -text {Extended Info} -variable ExtendedInfo 

    frame $base.fra18 \

        -borderwidth 2 -height 75 -relief groove -width 125 

    label $base.fra18.lab19 \

        -borderwidth 1 -font {Helvetica -12} -text {Max voices} 

    label $base.fra18.lab20 \

        -borderwidth 1 -font {Helvetica -12} -text {MPE usage (%)} 

    label $base.fra18.lab21 \

        -borderwidth 1 -font {Helvetica -12} -text {Voice Killing} 

    scale $base.fra18.sca22 \

        -borderwidth 1 \

        -command {SendPerfParam $maxVoices $cpuUsage $voiceKilling $reverbSwitch $chorusSwitch} \

        -font {Helvetica -12} -from 1.0 -orient horiz -to 32.0 \

        -variable maxVoices -width 10 

    scale $base.fra18.sca23 \

        -borderwidth 1 \

        -command {SendPerfParam $maxVoices $cpuUsage $voiceKilling $reverbSwitch $chorusSwitch} \

        -font {Helvetica -12} -orient horiz -resolution 5.0 \

        -variable cpuUsage -width 10 

    scale $base.fra18.sca24 \

        -borderwidth 1 \

        -command {SendPerfParam $maxVoices $cpuUsage $voiceKilling $reverbSwitch $chorusSwitch} \

        -font {Helvetica -12} -orient horiz -to 4.0 -variable voiceKilling \

        -width 10 

    checkbutton $base.fra18.che26 \

        \

        -command {SendPerfParam $maxVoices $cpuUsage $voiceKilling $reverbSwitch $chorusSwitch} \

        -font {Helvetica -12} -text Reverb -variable reverbSwitch 

    checkbutton $base.fra18.che27 \

        \

        -command {SendPerfParam $maxVoices $cpuUsage $voiceKilling $reverbSwitch $chorusSwitch} \

        -font {Helvetica -12} -text Chorus -variable chorusSwitch 



    scale $base.fra18.sca28 \

        -borderwidth 1 \

        -command {Volume $synthVol $pcmVol} \

        -font {Helvetica -12} -orient horiz -to 1.0 -variable synthVol \

        -width 10 -resolution 0.01

    scale $base.fra18.sca29 \

        -borderwidth 1 \

        -command {Volume $synthVol $pcmVol} \

        -font {Helvetica -12} -orient horiz -to 1.0 -variable pcmVol \

        -width 10 -resolution 0.01





    label $base.fra18.lab17 \

        -borderwidth 1 -font {Helvetica -12} -text SynthVol: 

    label $base.fra18.lab23 \

        -borderwidth 1 -font {Helvetica -12} -text PCMVol: 

    label $base.fra18.lab18 \

        -borderwidth 1 -font {Helvetica -12} -text Agressive 

    label $base.fra18.lab22 \

        -borderwidth 1 -font {Helvetica -12} -text Soft 

    ###################

    # SETTING GEOMETRY

    ###################

    place $base.lab19 \

        -x 125 -y 5 -anchor nw -bordermode ignore 

    place $base.but22 \

        -x 55 -y 250 -anchor nw -bordermode ignore 

    place $base.lab17 \

        -x 105 -y 35 -width 141 -height 18 -anchor nw -bordermode ignore 

    place $base.fra17 \

        -x 10 -y 60 -width 150 -height 90 -anchor nw -bordermode ignore 

    place $base.fra17.but19 \

        -x 10 -y 5 -width 122 -height 26 -anchor nw -bordermode ignore 

    place $base.fra17.but17 \

        -x 10 -y 45 -width 32 -height 26 -anchor nw -bordermode ignore 

    place $base.fra17.but18 \

        -x 55 -y 45 -width 32 -height 26 -anchor nw -bordermode ignore 

    place $base.fra17.che21 \

        -x 100 -y 45 -anchor nw -bordermode ignore 

    place $base.fra20 \

        -x 10 -y 185 -width 150 -height 55 -anchor nw -bordermode ignore 

    place $base.fra20.lab21 \

        -x 5 -y 5 -anchor nw -bordermode ignore 

    place $base.fra20.lab22 \

        -x 5 -y 25 -anchor nw -bordermode ignore 

    place $base.fra20.lab24 \

        -x 90 -y 5 -anchor nw -bordermode ignore 

    place $base.fra20.lab25 \

        -x 90 -y 25 -anchor nw -bordermode ignore 

    place $base.fra20.lab18 \

        -x 125 -y 25 -anchor nw -bordermode ignore 

    place $base.che17 \

        -x 35 -y 155 -anchor nw -bordermode ignore 

    place $base.fra18 \

        -x 170 -y 60 -width 190 -height 220 -anchor nw -bordermode ignore 

    place $base.fra18.lab19 \

        -x 5 -y 20 -anchor nw -bordermode ignore 

    place $base.fra18.lab20 \

        -x 5 -y 60 -anchor nw -bordermode ignore 

    place $base.fra18.lab21 \

        -x 5 -y 100 -anchor nw -bordermode ignore 

    place $base.fra18.sca22 \

        -x 95 -y 5 -width 89 -height 32 -anchor nw -bordermode ignore 

    place $base.fra18.sca23 \

        -x 95 -y 45 -width 89 -height 32 -anchor nw -bordermode ignore 

    place $base.fra18.sca24 \

        -x 95 -y 85 -width 89 -height 32 -anchor nw -bordermode ignore 

    place $base.fra18.sca28\

        -x 95 -y 125 -width 89 -height 32 -anchor nw -bordermode ignore 

    place $base.fra18.sca29 \

        -x 95 -y 155 -width 89 -height 32 -anchor nw -bordermode ignore 

    place $base.fra18.che26 \

        -x 40 -y 190 -anchor nw -bordermode ignore 

    place $base.fra18.che27 \

        -x 120 -y 190 -anchor nw -bordermode ignore 

    place $base.fra18.lab17 \

        -x 5 -y 135 -anchor nw -bordermode ignore 

    place $base.fra18.lab23 \

        -x 5 -y 165 -anchor nw -bordermode ignore 

    place $base.fra18.lab18 \

        -x 95 -y 115 -anchor nw -bordermode ignore 

    place $base.fra18.lab22 \

        -x 160 -y 115 -anchor nw -bordermode ignore 

}



Window show .

Window show .top17



main $argc $argv

