/*-------------------------------------------------------------------------------------------------
 * Copyright (c) 1995-2001, VM Labs, Inc., All rights reserved.
 * Confidential and Proprietary Information of VM Labs, Inc
-------------------------------------------------------------------------------------------------*/
// derived class to add a couple of Nuon-specific methods to hsGFontList
// removes the knowledge of sysfont, etc from this library (even if linked in
// at compile time, this allows fonts to be outside the Impulse library

#ifndef NUON_FONTLIST_H
#define NUON_FONTLIST_H

#include "hsGFont.h"


struct FontRamBlock {
	void *fontMemStart;
	UInt32 length;
};

class NuonFontList : public hsGFontList {

public:
	static char **mInitFontFileNames;
	static FontRamBlock **mInitFontRamBlks;

	static void SetInitFileList (char **initFontFileNames) 
								{ mInitFontFileNames = initFontFileNames; }
	static void SetInitRamBlks (FontRamBlock **initFontRamBlks)
								{ mInitFontRamBlks = initFontRamBlks; }

	static hsGFontID	AddAllocatedFont(UInt32 length, void* sfnt, hsBool doDelete, UInt32 format=0);
	static hsGFontID	AddAllocatedFont(FontRamBlock *blk, hsBool doDelete, UInt32 format=0);
};

#endif  //NUON_FONTLIST_H