/*
 * cache related defines
 *
 * Copyright (c) 1998-2000 VM Labs, Inc. All rights reserved.
 * Confidential and Proprietary Information of VM Labs, Inc.
 * These materials may be used or reproduced solely under
 * an express written license from VM Labs, Inc.
 */

 /* $Id: cache.h,v 1.6 2000/10/25 20:33:25 cheiny Exp $ */

#ifndef _CACHE_H
#define _CACHE_H

#ifdef __cplusplus
extern "C" {
#endif

#define CACHE_WAY(n) (((n)-1)<<8)
#define CACHE_DIRECT CACHE_WAY(1)
#define CACHE_2WAY   CACHE_WAY(2)
#define CACHE_3WAY   CACHE_WAY(3)

#define CACHE_WAYSIZE_1K (0<<4)
#define CACHE_WAYSIZE_2K (1<<4)
#define CACHE_WAYSIZE_4K (2<<4)
#define CACHE_WAYSIZE_8K (3<<4)

#define CACHE_BLOCKSIZE_16 0
#define CACHE_BLOCKSIZE_32 1
#define CACHE_BLOCKSIZE_64 2
#define CACHE_BLOCKSIZE_128 3

void _DCacheFlush(void);
void _DCacheSync(void);
void _DCacheSyncRegion(void *startaddr, void *endaddr);
void _DCacheInvalidateRegion(void *startaddr, void *endaddr);

void _CacheConfig(unsigned int dcachectl, unsigned int icachectl);

#ifdef __cplusplus
}
#endif

#endif
