//****************************************************************
// TITLE :  Nuon MPEG (FMV: Full-Motion Video) definitions 
//
// FILE  :	mpeg.h
//
// DATE  :	
//
//	        Copyright (c) 1995-1999, VM Labs, Inc., All rights reserved.
//          Confidential and Proprietary Information of VM Labs, Inc.
//          These materials may be used or reproduced solely under an express
//          written license from VM Labs, Inc.
//
//**************************************************************** 

//--------------------------------
typedef struct {

    // MPEG Sequence Info (may change with each new sequence)
    long width;	    // horizontal size in pixels
    long height;	// vertical size in pixels
    long progseq;	// progressive or interlaced sequence
    long aspect;	// aspect ratio
    long is_mpeg2;  // is mpeg2 or mpeg1 flag

    // MPEG Picture Info (may change with each new picture)
    long fb;        // MPEG frame buffer
    long pType;     // picture coding type
    long pStruct;	// picture structure frame/field
    long tff;	    // top field first bit
    long rff;	    // repeat first field bit
    long pf;		// progressive frame 
    long tRef;		// temporal reference value

} MpegInfo;

//--------------------------------

void StartMPEG(void);
MpegInfo *GetNextMpegFrame(void);


