/* Copyright (c) 1995-1998, VM Labs, Inc., All rights reserved.
 * Confidential and Proprietary Information of VM Labs, Inc
 */

;===================================
;	Macros
;===================================
	.macro	setParamAddr	offset, ptrAddr
		add		#offset, r1, r4	
		mv_s	#ptrAddr, r5 
		st_s	r4, (r5)
	.mend


	.macro	storeIndirectDtram	storeInstr, ptrAddr, value, toReg
		mv_s		#ptrAddr, toReg		//STOREIndirectDtram
		ld_s		(toReg), toReg
		nop
		storeInstr	value, (toReg)
	.mend


	.macro	storeSysram		storeInstr, Addr, value, toReg
		mv_s		#Addr, toReg		//STORESysram
		storeInstr	value, (toReg)
	.mend


	.macro	loadIndirectDtram	loadInstr, ptrAddr, fromReg, toReg
		mv_s		#ptrAddr, fromReg	//LOADIndirectDtram
		ld_s		(fromReg), fromReg
		nop
		.nooptimize
		loadInstr	(fromReg), toReg
		nop
		.optimize
	.mend


	.macro	loadSysram		loadInstr, Addr, fromReg, toReg
		mv_s		#Addr, fromReg		//LOADSysram
		loadInstr	(fromReg), toReg
		nop
	.mend


	.macro	STORE	IsGlobal, storeInstr, ptrAddr, value, toReg
		.if (IsGlobal == _FALSE)
			storeIndirectDtram storeInstr, ptrAddr, value, toReg
		.else
			storeSysram storeInstr, ptrAddr, value, toReg
		.endif
	.mend


	.macro LOAD		IsGlobal, loadInstr, ptrAddr, fromReg, toReg
		.if (IsGlobal == _FALSE)
			loadIndirectDtram	loadInstr, ptrAddr, fromReg, toReg
		.else
			loadSysram		loadInstr, ptrAddr, fromReg, toReg
		.endif
	.mend
