/*
 * MML 3D lighting functions
 *
 * Copyright (c) 1997-1998 VM Labs, Inc.
 * All rights reserved.
 * Confidential and Proprietary Information
 * of VM Labs, Inc.
 */

#include <stdlib.h>
#include "m3d.h"

/*
 * initialize a lighting structure
 */

void
m3dInitLights(m3dLightData *light, m3dreal ambient)
{
    /* convert ambient from 16.16 to 4.28 */
    light->ambient = ambient << 12;
    light->numlights = 0;
}

/*
 * add a directional light to a lighting
 * structure
 */

void
m3dAddDirectionalLight(m3dLightData *light, m3dreal x, m3dreal y, m3dreal z, m3dreal intense)
{
    int i;

    i = light->numlights;
    if (i < 3) {
	light->li[i].x = (x << 14);
	light->li[i].y = (y << 14);
	light->li[i].z = (z << 14);
	light->li[i].intense = (intense << 12);
	light->numlights++;
    }
}
