/*
 * DMA to/from an MPE
 *
 * Copyright (c) 2000 VM Labs, Inc. All rights reserved.
 * Confidential and Proprietary Information of VM Labs, Inc.
 * These materials may be used or reproduced solely under
 * an express written license from VM Labs, Inc.
 *
 */

#include <nuon/mutil.h>
#include <nuon/dma.h>

/* write data to another MPE from external memory */
void _mpedma(long dmaflags, void *extaddr, void *intern, int mpe)
{
    // convert internal address to a system address
    intern = (mpe<<23) + (char *)intern;

    // set the REMOTE bit on the transfer
    dmaflags |= (1<<28);

    _DMALinear(dmaflags, extaddr, intern);
}

/* read/write another MPE's register */
long
_mpedmaregister(long dmaflags, void *externaddr, long data, int mpe)
{
    void *localmem;

    localmem = _MemLocalScratch(0);
    _SetLocalVar(localmem, data);
    externaddr = (mpe<<23) + (char *)externaddr;

    _DMALinear(dmaflags, externaddr, localmem);
    return _GetLocalVar(localmem);
}

/* read/write other bus memory, 32 bits only */
long
_obusdmascalar(long dmaflags, void *externaddr, long data)
{
    return _mpedmaregister(dmaflags, externaddr, data, 0);
}

