/*
 * Copyright (c) 1998, VM Labs, Inc., All rights reserved.
 * Confidential and Proprietary Information of VM Labs, Inc
 *
 * Written by Mike Fulton, VM Labs, Inc.
 *
 */

#include <stdlib.h>
#include <nuon/mml2d.h>
#include <nuon/bios.h>
#include <nuon/dma.h>

#include "dmacalls.h"

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

void odma_command(void *cmd)
{
register volatile long *dcachestatus = 	(long *)0x20500FF8;
register volatile long *odmactrl = 	(long *)0x20500500;
register long *odmacptr = 			(long *)0x20500510;

	while( *dcachestatus & 0xF0000000 );	// Make sure we don't hit 
											// DCACHE / ODMA bug
	
	while( *odmactrl & 0x0000001F);			// Wait for PENDING and BUSY bits to clear
	
	*odmacptr = (long)cmd;					// Issue command
}

void mdma_command(void *cmd)
{
register volatile long *mdmactrl = 	(long *)0x20500600;
register long *mdmacptr = 			(long *)0x20500610;

	while( *mdmactrl & 0x00000010 );		// Wait for PENDING and BUSY bits to clear
	*mdmacptr = (long)cmd;
}

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

void odma_clear(void)
{
register volatile long *odmactrl = 	(long *)0x20500500;

	while( *odmactrl & 0x0000001F );
}

void mdma_clear(void)
{
register volatile long *mdmactrl = 	(long *)0x20500600;

	while( *mdmactrl & 0x0000001F );
}

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

int odma_status(void)
{
register volatile long *odmactrl = 	(long *)0x20500500;

	return( *odmactrl & 0x0000000F );
}

int mdma_status(void)
{
register volatile long *mdmactrl = 	(long *)0x20500600;

	return( *mdmactrl & 0x0000000F );
}


