#
# Makefile Include to specify program names
#
# Copyright (c) 2000 VM Labs, Inc. All rights reserved.
# Confidential and Proprietary Information of VM Labs, Inc.
#

########################

ifeq ($(BUILDHOST),linux)

ROOT = /usr/local/merlin-local
CC = mgcc
CXX = mg++
AS = llama -fcoff -nologo -c -g $(DEFINES)
LD = vmld
AR = vmar
RM = rm -f

else

ROOT = /vmlabs
CC = mgcc
AS = llama -fcoff -nologo -c -g $(DEFINES)
LD = vmld
AR = vmar
RM = erase

endif

########################
# Provide build rule for C++ files that use ".cpp" extension instead of ".C" or ".cc"

.SUFFIXES: .cpp .o

.cpp.o:
	$(CXX) -c -o $@ $(CXXFLAGS) $<


########################
# Provide default rule for C source files

.c.o:
	$(CC) $(CFLAGS) -c $< -o $*.o


########################
# Provide default rule for Assembly source files

.s.o:
	$(AS) -o $@ $<


